const dbConnection = require("../db/connection");

const fs = require("fs");

require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

ajustesController = {};

arrayLog = []; 

let ajustesMatrix = [];

let msgLog = [];

// * Carga la página del controlador.
ajustesController.ajustes_loadpage = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
	res.send("API ajustes");
};

//* Creación de un nuevo ajuste
ajustesController.ajustes_create_post = (req, res) => {
	let counter = 0;
	const ajustes = req.body;
	if (!ajustes) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else { 
        console.table(ajustes);
        //* Obtener el utlimo ID de ajustes
        // const queryAjusteID = "SELECT CAST(id AS UNSIGNED) + 1 as nuevoId FROM ajustes WHERE idUsuarios = ? ORDER BY id DESC LIMIT 1;";
		const queryAjusteID = "SELECT CAST(id AS UNSIGNED) + 1 as nuevoId FROM ajustes ORDER BY id DESC LIMIT 1;";
        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                console.error("TRANSACTION ERROR :>> ", err);
            } else {
                dbConnection.connectionDB.query(queryAjusteID, [ajustes.idUsuarios], (error, response, result) => {
                    if (error) {
                        dbConnection.connectionDB.rollback(() => {
                            console.log("QUERY > ROLLBACK ERROR SELECT (LAST ID +1) ajustes :>> ", error);
                            const status = globalFunctions.statusMsg(0);
                            msgLog.length = 0;
                            msgLog.push(status);
                            res.json(msgLog);
                            msgLog.length = 0;
                        });
                    } else if (response) {
                        console.log("QUERY RESULT (LAST ID +1) ajustes :>> ");
                        console.log(response);
                        const nuevoID = response[0].nuevoId;
						//* Obtener el nuevo correlativo y el documento concatenado.
						const queryCorrelativoID = "SELECT concat_ws('-', prefijo, serie,idEmpresas) AS documento, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo FROM documentosCorrelativos WHERE idDocumentos = ? AND idUsuarios = ?;";
						dbConnection.connectionDB.query(queryCorrelativoID,[ajustes.idTipoAjustes, ajustes.idUsuarios], (error, response, result) => {
							var documento = "";
							var nuevoCorrelativo = 0;
							if (error) {
								dbConnection.connectionDB.rollback(() => {
									console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
									const status = globalFunctions.statusMsg(0);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else if (response) {
								console.log(response.length);
								if (response.length == 0){
									console.log("QUERY > ROLLBACK ERROR INSERT comprasOrdenes :>> El usuario no cuenta con documentos correlativos.");
									//!IMPLEMENTAR QUERY PARA CREARLE AL USUARIO UN DOC CORRELATIVO
									if(ajustes.idTipoAjustes == 3){ //Entrada
										var queryPrefijoSerie = "SELECT CONCAT_WS(' ','ENTRADA', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(roles.descripcion, 1, 1),'E',usuarios.id) AS serie FROM usuarios "
										+ "LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = ?;";
									}else if (ajustes.idTipoAjustes == 5){ // Salida
										var queryPrefijoSerie = "SELECT CONCAT_WS(' ','SALIDA', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(roles.descripcion, 1, 1),'S',usuarios.id) AS serie FROM usuarios "
										+ "LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = ?;";
									}
									dbConnection.connectionDB.query(queryPrefijoSerie,[ajustes.idUsuarios], (error, response, result) => {
										if (error) {
											dbConnection.connectionDB.rollback(() => {
												console.log("QUERY > ROLLBACK ERROR SELECT prefijo y serie :>> ", error);
												const status = globalFunctions.statusMsg(0);
												msgLog.length = 0;
												msgLog.push(status);
												res.json(msgLog);
												msgLog.length = 0;
											});
										} else if (response) {
											const prefijo = response[0].prefijo;
											const serie = response[0].serie;

											const query = "INSERT INTO documentosCorrelativos (idDocumentos,prefijo,serie,correlativo,idFormatos,idAvailablePrint,idUsuarios,idEmpresas,created_at) VALUES (?,?,?,1,0,1,?,?,CURRENT_TIMESTAMP());";
											dbConnection.connectionDB.query(query,[ajustes.idTipoAjustes,prefijo,serie,ajustes.idUsuarios,ajustes.idEmpresas], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT Creación del documento correlativo :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												}
											});
											const queryNuevoCorrelativo = "SELECT concat_ws('-', prefijo, serie,idEmpresas) AS documento, CAST(correlativo AS UNSIGNED) + 1 AS nuevoCorrelativo FROM documentosCorrelativos WHERE idDocumentos = ? AND idUsuarios = ?;";
											dbConnection.connectionDB.query(queryNuevoCorrelativo,[ajustes.idTipoAjustes,ajustes.idUsuarios], (error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR SELECT (correlativo +1) :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else if (response) {
													console.log("QUERY RESPONSE (NUEVO correlativo +1) :>> ");
													console.log(response);
													documento = response[0].documento;
													nuevoCorrelativo = response[0].nuevoCorrelativo;

													//* Insertar los encabezados en la tabla de ajustes.
													const queryInsertAjustes = "INSERT INTO ajustes (id,inventario,idPunto,documento,idTipoAjustes,descripcion,idUsuarios,noFactura,idEmpresas) VALUES (?,?,?,?,?,?,?,?,?);";
													dbConnection.connectionDB.query(queryInsertAjustes,
														[
															nuevoID,
															ajustes.inventario,
															ajustes.idPunto,
															documento,
															ajustes.idTipoAjustes,
															ajustes.descripcion,
															ajustes.idUsuarios,
															ajustes.noFactura,
															ajustes.idEmpresas
														],(error, response, result) => {
															if (error) {
																if (error.code == 'ER_DUP_ENTRY') {
																	dbConnection.connectionDB.rollback(() => {
																		console.log("QUERY > ROLLBACK ERROR INSERT ajustes :>> ", error);
																		const status = globalFunctions.statusMsg(6);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	});
																} else {
																	dbConnection.connectionDB.rollback(() => {
																		console.log("QUERY > ROLLBACK ERROR INSERT ajustes :>> ", error);
																		const status = globalFunctions.statusMsg(0);
																		msgLog.length = 0;
																		msgLog.push(status);
																		res.json(msgLog);
																		msgLog.length = 0;
																	});
																}
															} else if (response) {
																console.log("QUERY RESPONSE INSERT ajustes :>> ");
																console.log(response);

																//* Actualiza el correlativo en la tabla de documentosCorrelativos. 
																const queryCorrelativos = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = ? AND idUsuarios = ?;";
																dbConnection.connectionDB.query(queryCorrelativos,
																	[
																		nuevoCorrelativo,
																		ajustes.idTipoAjustes,
																		ajustes.idUsuarios,
																		//idEmpresas
																	],(error, response, result) => {
																		if (error) {
																			if (error.code == 'ER_DUP_ENTRY') {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(6);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			} else {
																				dbConnection.connectionDB.rollback(() => {
																					console.log("QUERY > ROLLBACK ERROR UPDATE Correlativo :>> ", error);
																					const status = globalFunctions.statusMsg(0);
																					msgLog.length = 0;
																					msgLog.push(status);
																					res.json(msgLog);
																					msgLog.length = 0;
																				});
																			}
																		} else if (response) {
																			
																			console.log("QUERY RESPONSE CORRELATIVO :>> ");
																			console.log(response);
																			console.log(nuevoCorrelativo);

																			//* Actualizar el idAjustes a todos los productos que tengan 0 en ajustesDetalle
																			const queryUpdateDetalles = "UPDATE ajustesDetalle SET idAjustes= ? WHERE idAjustes = 0 AND idUsuarios = ?;";
																			dbConnection.connectionDB.query(queryUpdateDetalles,
																				[nuevoID,ajustes.idUsuarios],(error, response, results) => {
																					if (error) {
																						dbConnection.connectionDB.rollback(() => {
																							console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> ", error);
																							const status = globalFunctions.statusMsg(0);
																							msgLog.length = 0;
																							msgLog.push(status);
																							res.json(msgLog);
																							msgLog.length = 0;
																						});
																					} else if (response) {
																						console.log("QUERY RESPONSE UPDATE productos detalle :>> ");
																						console.log(response);
																						if(response.affectedRows == 0){
																							dbConnection.connectionDB.rollback(() => {
																								console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> El usuario no cuenta con ajustes pendientes");
																								const status = globalFunctions.statusMsg(4);
																								msgLog.length = 0;
																								msgLog.push(status);
																								res.json(msgLog);
																								msgLog.length = 0;
																							});
																						}else{
																							//* Obtener el saldo de cada uno de los productos agregados
																							ajustesMatrix =  [...ajustes.productos];
																							console.log(ajustesMatrix);
																							//idUsuarios en la tabla*
																							const queryInventario = "SELECT * FROM inventarios WHERE idProductos = ? ORDER BY id DESC LIMIT 1;";
																							ajustesMatrix.forEach((arr,index) => {
																								if ([arr].includes(null)) {
																									console.log(`Fila ${index + 2}: Completar registros vacíos.`);
																									msgLog.push(`Fila ${index + 2}: Completar registros vacíos.`);
																									counter++;
																									if (counter == ajustesMatrix.length){
																										console.log(msgLog);
																										res.json(msgLog);
																										msgLog.length = 0;
																									}
																								} else if (![arr].includes(null)) {
																									dbConnection.connectionDB.query(queryInventario,
																										[arr.id],(error, response, result) => {
																											if (msgLog.length > 0) {
																												dbConnection.connectionDB.rollback(
																													() => {
																														console.log("ROLLBACK EMPTY FIELDS :>> ");
																														console.log(msgLog);
																														res.json(msgLog);
																														msgLog.length = 0;
																													},
																												);
																											} else {
																												if (error) {
																													dbConnection.connectionDB.rollback(() => {
																														console.log("QUERY > ROLLBACK ERROR SELECT inventario :>> ", error);
																														const status = globalFunctions.statusMsg(0);
																														msgLog.length = 0;
																														msgLog.push(status);
																														res.json(msgLog);
																														msgLog.length = 0;
																													});
																												} else if (response) {
																													console.log("QUERY RESPONSE SELECT inventario:>> ");
																													console.log(response);
																													
																													if (ajustes.idTipoAjustes == 3){ //Entrada
																														var newSaldo = (response[0].saldo + arr.cantidad);
																														var query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento,idTipoProductos,idProductos,ingreso,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;
																													}else{ //Salida
																														var newSaldo = (response[0].saldo - arr.cantidad);
																														var query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento, idTipoProductos,idProductos,salida,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;
																													}
																													dbConnection.connectionDB.query(query,
																														[ajustes.inventario,ajustes.idPunto,documento,arr.idTipoProducto,arr.id,arr.cantidad,
																														newSaldo,ajustes.idUsuarios,ajustes.idEmpresas],(error, response, result) => {
																															if (error) {
																																dbConnection.connectionDB.rollback(() => {
																																	console.log("QUERY > ROLLBACK ERROR INSERT inventario :>> ", error);
																																	const status = globalFunctions.statusMsg(0);
																																	msgLog.length = 0;
																																	msgLog.push(status);
																																	res.json(msgLog);
																																	msgLog.length = 0;
																																});
																															} else if (response) {
																																console.log("QUERY RESPONSE INSERT inventario:>> ");
																																console.log(response);

																																dbConnection.connectionDB.commit(
																																	(err) => {
																																		if (err) {
																																			dbConnection.connectionDB.rollback(
																																				() => {
																																					console.log(
																																						"COMMIT ERROR ROLLBACK INSERT inventario :>>",
																																						err,
																																					);
																																				},
																																			);
																																		} else {
																																			counter++;
																																			if (counter == ajustesMatrix.length) {
																																				if (msgLog.length == 0) {
																																					msgLog.push("Ajustes cargados correctamente.");
																																				}
																																				console.log(msgLog);
																																				res.json(msgLog);
																																				msgLog.length = 0;
																																			}
																																		}
																																	},
																																);																										
																															}																								
																														},
																													);
																												}
																											}
																										}
																									);
																								}
																							}); 
																						}
																					}
																				},
																			);
																		}
																	}
																);
															}
														},
													);
												}
											});
										}
									});
								}else{
									console.log("QUERY RESPONSE (correlativo +1) :>> ");
									console.log(response);
									documento = response[0].documento;
									nuevoCorrelativo = response[0].nuevoCorrelativo;
								
									//* Insertar los encabezados en la tabla de ajustes.
									const queryInsertAjustes = "INSERT INTO ajustes (id,inventario,idPunto,documento,idTipoAjustes,descripcion,idUsuarios,noFactura,idEmpresas) VALUES (?,?,?,?,?,?,?,?,?);";
									dbConnection.connectionDB.query(queryInsertAjustes,
										[
											nuevoID,
											ajustes.inventario,
											ajustes.idPunto,
											documento,
											ajustes.idTipoAjustes,
											ajustes.descripcion,
											ajustes.idUsuarios,
											ajustes.noFactura,
											ajustes.idEmpresas
										],(error, response, result) => {
											if (error) {
												if (error.code == 'ER_DUP_ENTRY') {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT ajustes :>> ", error);
														const status = globalFunctions.statusMsg(6);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR INSERT ajustes :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												}
											} else if (response) {
												console.log("QUERY RESPONSE INSERT ajustes :>> ");
												console.log(response);

												//* Actualiza el correlativo en la tabla de documentosCorrelativos. 
												const queryCorrelati = "UPDATE documentosCorrelativos SET correlativo = ? WHERE idDocumentos = ? AND idUsuarios = ?;";
												dbConnection.connectionDB.query(queryCorrelati,
													[
														nuevoCorrelativo,
														ajustes.idTipoAjustes,
														ajustes.idUsuarios,
														//idEmpresas
													],(error, response, result) => {
														if (error) {
															if (error.code == 'ER_DUP_ENTRY') {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE correlativo :>> ", error);
																	const status = globalFunctions.statusMsg(6);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else {
																dbConnection.connectionDB.rollback(() => {
																	console.log("QUERY > ROLLBACK ERROR UPDATE Correlativo :>> ", error);
																	const status = globalFunctions.statusMsg(0);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															}
														} else if (response) {
															
															console.log("QUERY RESPONSE CORRELATIVO :>> ");
															console.log(response);
															console.log(nuevoCorrelativo);

															//* Actualizar el idAjustes a todos los productos que tengan 0 en ajustesDetalle
															const queryUpdateDetalles = "UPDATE ajustesDetalle SET idAjustes= ? WHERE idAjustes = 0 AND idUsuarios = ?;";
															dbConnection.connectionDB.query(queryUpdateDetalles,
																[nuevoID,ajustes.idUsuarios],(error, response, results) => {
																	if (error) {
																		dbConnection.connectionDB.rollback(() => {
																			console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> ", error);
																			const status = globalFunctions.statusMsg(0);
																			msgLog.length = 0;
																			msgLog.push(status);
																			res.json(msgLog);
																			msgLog.length = 0;
																		});
																	} else if (response) {
																		console.log("QUERY RESPONSE UPDATE productos detalle :>> ");
																		console.log(response);
																		if(response.affectedRows == 0){
																			dbConnection.connectionDB.rollback(() => {
																				console.log("QUERY > ROLLBACK ERROR UPDATE productos detalle :>> El usuario no cuenta con ajustes pendientes");
																				const status = globalFunctions.statusMsg(4);
																				msgLog.length = 0;
																				msgLog.push(status);
																				res.json(msgLog);
																				msgLog.length = 0;
																			});
																		}else{
																			//* Obtener el saldo de cada uno de los productos agregados
																			ajustesMatrix =  [...ajustes.productos];
																			console.log(ajustesMatrix);
																			//idUsuarios en la tabla*
																			const queryInventario = "SELECT * FROM inventarios WHERE idProductos = ? ORDER BY id DESC LIMIT 1;";
																			ajustesMatrix.forEach((arr,index) => {
																				if ([arr].includes(null)) {
																					console.log(`Fila ${index + 2}: Completar registros vacíos.`);
																					msgLog.push(`Fila ${index + 2}: Completar registros vacíos.`);
																					counter++;
																					if (counter == ajustesMatrix.length){
																						console.log(msgLog);
																						res.json(msgLog);
																						msgLog.length = 0;
																					}
																				} else if (![arr].includes(null)) {
																					dbConnection.connectionDB.query(queryInventario,
																						[arr.id],(error, response, result) => {
																							if (msgLog.length > 0) {
																								dbConnection.connectionDB.rollback(
																									() => {
																										console.log("ROLLBACK EMPTY FIELDS :>> ");
																										console.log(msgLog);
																										res.json(msgLog);
																										msgLog.length = 0;
																									},
																								);
																							} else {
																								if (error) {
																									dbConnection.connectionDB.rollback(() => {
																										console.log("QUERY > ROLLBACK ERROR SELECT inventario :>> ", error);
																										const status = globalFunctions.statusMsg(0);
																										msgLog.length = 0;
																										msgLog.push(status);
																										res.json(msgLog);
																										msgLog.length = 0;
																									});
																								} else if (response) {
																									console.log("QUERY RESPONSE SELECT inventario:>> ");
																									console.log(response);
																									
																									if (ajustes.idTipoAjustes == 3){ //Entrada
																										var newSaldo = (response[0].saldo + arr.cantidad);
																										var query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento,idTipoProductos,idProductos,ingreso,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;
																									}else{ //Salida
																										var newSaldo = (response[0].saldo - arr.cantidad);
																										var query = `INSERT INTO inventarios (idTipoInventario,ingresoA,idPuntoIngreso,documento, idTipoProductos,idProductos,salida,saldo,idUsuarios,idEmpresas) values (1,?,?,?,?,?,?,?,?,?);`;
																									}
																									dbConnection.connectionDB.query(query,
																										[ajustes.inventario,ajustes.idPunto,documento,arr.idTipoProducto,arr.id,arr.cantidad,
																										newSaldo,ajustes.idUsuarios,ajustes.idEmpresas],(error, response, result) => {
																											if (error) {
																												dbConnection.connectionDB.rollback(() => {
																													console.log("QUERY > ROLLBACK ERROR INSERT inventario :>> ", error);
																													const status = globalFunctions.statusMsg(0);
																													msgLog.length = 0;
																													msgLog.push(status);
																													res.json(msgLog);
																													msgLog.length = 0;
																												});
																											} else if (response) {
																												console.log("QUERY RESPONSE INSERT inventario:>> ");
																												console.log(response);

																												dbConnection.connectionDB.commit(
																													(err) => {
																														if (err) {
																															dbConnection.connectionDB.rollback(
																																() => {
																																	console.log(
																																		"COMMIT ERROR ROLLBACK INSERT inventario :>>",
																																		err,
																																	);
																																},
																															);
																														} else {
																															counter++;
																															if (counter == ajustesMatrix.length) {
																																if (msgLog.length == 0) {
																																	msgLog.push("Ajustes cargados correctamente.");
																																}
																																console.log(msgLog);
																																res.json(msgLog);
																																msgLog.length = 0;
																															}
																														}
																													},
																												);																										
																											}																								
																										},
																									);
																								}
																							}
																						}
																					);
																				}
																			}); 
																		}
																	}
																},
															);
														}
													}
												);
											}
										},
									);

								}
							}
						});
                    }
                });
            }
        });
	}
}

//* Vista de ajustes
ajustesController.ajustes_view = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const empresa = req.body;
	//console.log(empresa);
	if (!empresa) {
		msgLog.push("No hay información a solicitar.");
		res.status(200).json(msgLog);
		msgLog.length = 0;
	} else if (empresa) {
		console.log("entra :>> ");	
		console.log(empresa.id);	
		const queryEmpresa = "SELECT nombreComercial FROM empresas WHERE id= ?;";	
		dbConnection.connectionDB.query(queryEmpresa, empresa.id, (error, results) => {	
			if (error) {	
				globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);	
				throw error;	
			} else if (results.length > 0) {	
				globalFunctions.logger(logger_data(req), 'info', logger_msg.info);

				const nombreComercial = results[0].nombreComercial;	
				const query_vw_ajustes = "SELECT * FROM vw_ajustes WHERE idEmpresas= ?;";

				dbConnection.connectionDB.query(query_vw_ajustes, nombreComercial, (error, results) => {	
					if(error){	
						globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);	
						throw error;	
					} else {
						res.json(results);

					}
				});
			} else {
				res.send("Sin resultados");
			}
		});
	}
}

//* Insert para todo producto agregado en el carrito.
ajustesController.ajustes_create_productos = (req, res) => {
	const productos = req.body;
	console.table(productos);
	const query =
		"INSERT INTO ajustesDetalle (idAjustes,idProductos,cantidad,idUsuarios) VALUES (0, ? , ? , ?);";
	dbConnection.connectionDB.beginTransaction((err) => {
		if (err) {
			console.error("TRANSACTION ERROR :>> ", err);
		} else {
			dbConnection.connectionDB.query(query,[productos.id,productos.cantidad,productos.idUsuarios],(error, response, result) => {
					if (error) {
						dbConnection.connectionDB.rollback(() => {
							console.log("QUERY > ROLLBACK ERROR INSERT productos :>> ", error);
							const status = globalFunctions.statusMsg(0);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						});
					} else if (response) {
						dbConnection.connectionDB.commit((err) => {
							if (err) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK INSERT productos :>> ",
										err,
									);
								});
							} else {
								const status = globalFunctions.statusMsg(1);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							}
						});
						console.log("QUERY RESPONSE INSERT productos <ajustesDetalle>  :>> ");
						console.log(response);
						console.log("Producto cargado correctamente");
					}
				},
			);
	  	}
	});
};

//* Metodo para eliminar un producto
ajustesController.ajustes_delete_productos = (req, res) => {
	const productos = req.body;
	if (!productos) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(productos);
		const query = "DELETE FROM ajustesDetalle WHERE idAjustes = 0 AND idProductos = ? AND idUsuarios = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [productos.id,productos.idUsuarios],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' ajustesDetalle :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							if (response.affectedRows == 0){
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK 'DELETE' ajustesDetalle :>> No se encontraron resultados "
									);
									const status = globalFunctions.statusMsg(4);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							}else{
								dbConnection.connectionDB.commit((err) => {
									if (err) {
										dbConnection.connectionDB.rollback(() => {
											console.log(
												"COMMIT ERROR ROLLBACK 'DELETE' ajustesDetalle :>> ",
												err,
											);
											const status = globalFunctions.statusMsg(0);
											msgLog.length = 0;
											msgLog.push(status);
											res.json(msgLog);
											msgLog.length = 0;
										});
									} else {
										console.log("Ajuste detalle eliminado con exito");
										const status = globalFunctions.statusMsg(1);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									}
								});
							}
						}
					},
				);
			}
		});
	}
};

//* Metodo para eliminar un ajuste
ajustesController.ajustes_delete_post = (req, res) => {
	const ajustes = req.body;
	if (!ajustes) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(ajustes);
		const query = "DELETE FROM ajustes WHERE id = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [ajustes.id],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' ajustesDetalle :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							if (response.affectedRows == 0){
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"COMMIT ERROR ROLLBACK 'DELETE' ajustes :>> No se encontraron resultados "
									);
									const status = globalFunctions.statusMsg(4);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							}else{
								//* Se elimina tambien en ajustesDetalle el registro.
								const query = "DELETE FROM ajustesDetalle WHERE idAjustes = ?;";
								dbConnection.connectionDB.beginTransaction((err) => {
									if (err) {
										console.error("TRANSACTION ERROR :>> ", err);
									} else {
										dbConnection.connectionDB.query(query, [ajustes.id],
											(error, response, result) => {
												if (error) {
													dbConnection.connectionDB.rollback(() => {
														console.log("QUERY > ROLLBACK ERROR 'DELETE' ajustesDetalle :>> ", error);
														const status = globalFunctions.statusMsg(0);
														msgLog.length = 0;
														msgLog.push(status);
														res.json(msgLog);
														msgLog.length = 0;
													});
												} else if (response) {
													console.log("QUERY RESPONSE :>> ");
													console.log(response);
													if (response.affectedRows == 0){
														dbConnection.connectionDB.rollback(() => {
															console.log(
																"COMMIT ERROR ROLLBACK 'DELETE' ajustesDetalle :>> No se encontraron resultados "
															);
															const status = globalFunctions.statusMsg(4);
															msgLog.length = 0;
															msgLog.push(status);
															res.json(msgLog);
															msgLog.length = 0;
														});
													}else{
														dbConnection.connectionDB.commit((err) => {
															if (err) {
																dbConnection.connectionDB.rollback(() => {
																	console.log(
																		"COMMIT ERROR ROLLBACK 'DELETE' ajustes :>> ",
																		err,
																	);
																	const status = globalFunctions.statusMsg(0);
																	msgLog.length = 0;
																	msgLog.push(status);
																	res.json(msgLog);
																	msgLog.length = 0;
																});
															} else {
																console.log("Ajuste eliminado con exito");
																const status = globalFunctions.statusMsg(1);
																msgLog.length = 0;
																msgLog.push(status);
																res.json(msgLog);
																msgLog.length = 0;
															}
														});
													}
												}
											},
										);
									}
								});
							}
						}
					},
				);
			}
		});
	}
};

module.exports.ajustesController = ajustesController;
