const dbConnection = require("../db/connection");

// const readXlsxFile = require("read-excel-file/node");

const fs = require("fs");

require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

clientesController = {};

arrayLog = [];

let clientesMatrix = [];

let msgLog = [];
let counter = 0;

// * Carga la página del controlador.
clientesController.clientes_loadpage = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
	res.send("API clientes");
};

// * Traer datos de la base de datos.
clientesController.clientes_list = (req, res) => {
	// const query = "SELECT * FROM clientes";
	const query = "SELECT id, image, codigoC, nombreC, nombreF, contacto, docIdentificacion, nitC, (SELECT descripcion FROM paises WHERE id = clientes.idPaises) as idPaises, (SELECT descripcion FROM departamentos WHERE id = clientes.idDepartamentos) as idDepartamentos, (SELECT descripcion FROM municipios WHERE id = clientes.idMunicipios) as idMunicipios, zona, direccionC, telefonoC, mail, limiteCredito, diasCredito, (SELECT descripcion FROM tipoClientes WHERE id = clientes.idTipoClientes) as idTipoClientes, (SELECT descripcion FROM availableCreditLimit WHERE id = clientes.idAvailableCreditLimit) as idAvailableCreditLimit, (SELECT descripcion FROM nomenclatura WHERE id = clientes.idNomenclatura) as idNomenclatura, (SELECT descripcion FROM centrosCosto WHERE id = clientes.idCentrosCosto) as idCentrosCosto, (SELECT userName FROM usuarios WHERE id = clientes.idUsuarios) as idUsuarios, (SELECT descripcion FROM clasificacionClientes WHERE id = clientes.idClasificacionClientes) as idClasificacionClientes, (SELECT nombreComercial FROM empresas WHERE id = clientes.idEmpresas) as idEmpresas, (SELECT descripcion FROM agenteRetenedor WHERE id = clientes.idAgenteRetenedor) as idAgenteRetenedor, porcRetension FROM clientes;";
	dbConnection.connectionDB.query(query, (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length>0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

clientesController.clientes_detail = (req, res) => {
	const cliente = req.body;
	console.table(cliente);
	const query = "SELECT * FROM clientes WHERE id = ? AND idEmpresas = ? LIMIT 1"
	dbConnection.connectionDB.query(query, [cliente.id, cliente.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

clientesController.clientes_last_id = (req, res) => {
	const cliente = req.body;
	console.table(cliente);
	const query = "SELECT id FROM clientes ORDER BY id DESC LIMIT 1";
	dbConnection.connectionDB.query(query, (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			if (response.length == 0) {
				res.json([{ id: 0 }]);
			} else {
				res.json(response);
			}			
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

clientesController.clientes_create_post = (req, res) => {
	const cliente = req.body;

	if (!cliente) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		if (!cliente.codigoC ||
			!cliente.nombreC ||
			!cliente.contacto ||
			!cliente.nitC ||
			!cliente.zona ||
			!cliente.direccionC ||
			!cliente.telefonoC) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			console.table(cliente);
			// const queryCodigoC = "SELECT codigoC FROM clientes WHERE codigoC = ?;"; 
			const queryCodigoC = "SELECT EXISTS(SELECT codigoC FROM clientes WHERE codigoC = ?) AS codigoClienteExists;";

			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(queryCodigoC, [cliente.codigoC], (error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR SELECT codigoClienteExists :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);

							if (response[0].codigoClienteExists == 1) {
								dbConnection.connectionDB.rollback(() => {
									const status = globalFunctions.statusMsg(6);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								});
							} else if (response[0].codigoClienteExists == 0) {
								const queryInsert = "INSERT INTO clientes (codigoC, nombreC, nombreF, contacto, nitC, zona, direccionC, telefonoC, idEmpresas, created_at) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, CURRENT_TIMESTAMP())";

								dbConnection.connectionDB.query(
									queryInsert,
									[
										cliente.codigoC,
										cliente.nombreC,
										cliente.nombreC,
										cliente.contacto,
										cliente.nitC,
										cliente.zona,
										cliente.direccionC,
										cliente.telefonoC,
										cliente.idEmpresas
									],
									(error, response, result) => {
										if (error) {
											if (error.code == 'ER_DUP_ENTRY') {
												dbConnection.connectionDB.rollback(() => {
													console.log("QUERY > ROLLBACK ERROR INSERT clientes :>> ", error);
													const status = globalFunctions.statusMsg(6);
													msgLog.length = 0;
													msgLog.push(status);
													res.json(msgLog);
													msgLog.length = 0;
												});
											} else {
												dbConnection.connectionDB.rollback(() => {
													console.log("QUERY > ROLLBACK ERROR INSERT clientes :>> ", error);
													const status = globalFunctions.statusMsg(0);
													msgLog.length = 0;
													msgLog.push(status);
													res.json(msgLog);
													msgLog.length = 0;
												});
											}

										} else if (response) {
											console.log("QUERY RESULT :>> ");
											console.log(result);
											dbConnection.connectionDB.commit((err) => {
												if (err) {
													dbConnection.connectionDB.rollback(() => {
														console.log(
															"COMMIT ERROR ROLLBACK INSERT clientes :>> ",
															err,
														);
													});
												} else {
													const status = globalFunctions.statusMsg(1);
													msgLog.length = 0;
													msgLog.push(status);
													res.json(msgLog);
													msgLog.length = 0;
												}
											});
										}
									},
								);
							}

						}
					});
				}
			});
		}
	}
}

clientesController.clientes_update_post = (req, res) => {
	const cliente = req.body;
	if (!cliente) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(cliente);
		const query = "UPDATE clientes SET codigoC = ?, nombreC = ?, nombreF = ?, contacto = ?, nitC = ?, zona = ?, direccionC = ?, telefonoC = ?, updated_at = CURRENT_TIMESTAMP() WHERE id = ? AND idEmpresas = ?";

		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						cliente.codigoC,
						cliente.nombreC,
						cliente.nombreC,
						cliente.contacto,
						cliente.nitC,
						cliente.zona,
						cliente.direccionC,
						cliente.telefonoC,
						cliente.id,
						cliente.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE clientes :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE clientes :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}

clientesController.clientes_delete_post = (req, res) => {
	const cliente = req.body;
	if (!cliente) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(cliente);
		const query = "DELETE FROM clientes WHERE id = ? AND idEmpresas = ?";
		// /*
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [cliente.id, cliente.idEmpresas],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' usuarios :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
							console.log("QUERY RESULT :>> ");
							console.log(result);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK 'DELETE' clientes :>> ",
											err,
										);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						} else {
							const status = globalFunctions.statusMsg(4);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						}
					},
				);
			}
		});
		// */
	}
}

// #region carga de documentos
// * Descargar el documento a llenar.
clientesController.downloadfile = (req, res) => {
	const file = "assets/docs/clientes.xlsx";
	fs.access(file, fs.constants.F_OK, (err) => {
		if (err) {
			console.error("El archivo 'clientes' no existe.");
			msgLog.push("El archivo 'clientes' no existe.");
			res.status(404).json(msgLog);
			msgLog.length = 0;
		} else if (!err) {
			res.status(200).download(file);
			console.log("Archivo clientes descargado");
		}
	});
};

// * Guardar un archivo xlsx.
clientesController.savefile = (req, res) => {
	console.log("req.params :>> ", req.params.idEmpresas);
	let idEmpresa = req.params.idEmpresas;
	// ! Al recibir algo vacío.
	if (!req.file) {
		console.log("Debes subir un documento.");
		msgLog.push("Debes subir un documento.");
		res.json(msgLog);
		msgLog.length = 0;
	}

	let file_path = req.file.path;

	// ! Split de '\' para Windows.
	let file_split = file_path.split("\\");
	let file_name = file_split[2];
	let extension_split = file_name.split(".");
	let file_ext = extension_split[1];

	// * Valida la extensión del documento.
	if (file_ext != "xlsx") {
		// ! Borrar el documento subido.
		fs.unlink(file_path, (error) => {
			console.log(
				"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
			);
			msgLog.push(
				"El tipo de documento no es válido. Debes seleccionar un archivo .xlsx o descargar los proporcionados por el sistema.",
			);
			res.json(msgLog);
			msgLog.length = 0;
		});
	} else {
		readXlsxFile("../uploads/" + req.file.filename).then(
			(excelMatrix) => {
				// * excelMatrix es una matriz en donde cada 'fila' es un arreglo.
				console.log(excelMatrix);

				// * Valida que el documento ingresado sea el correcto.
				if (excelMatrix[0].length !== 20) {
					console.log("El documento no es válido para 'clientes'.");
					msgLog.push("El documento no es válido para 'clientes'.");
					// console.log(msgLog);
					res.json(msgLog);
					msgLog.length = 0;
				} else {
					// * Se remueve el primer arreglo o fila del archivo ingresado representado como 'excelMatrix'.
					excelMatrix.shift();

					// * Llenado de la segunda matriz con el idEmpresa.
					clientesMatrix = excelMatrix.map((arr) => [
						...arr,
						idEmpresa,
					]);
					console.log("clientesMatrix :>> ", clientesMatrix);

					// ! Abre la conexión a MySQL.
					// dbConnection.connectionDB.connect((error) => {
					// 	if (error) {
					// 		console.log("CONNECTION ERROR :>> ", error);
					// 		console.log(
					// 			"CONNECTION CLOSED BY ERROR AT CONNECTION.",
					// 		);
					// 		dbConnection.connectionDB.end();
					// 	}
					// });

					// ! Comienzo de transacción.
					dbConnection.connectionDB.beginTransaction((err) => {
						if (err) {
							console.log("TRANSACTION ERROR :>> ", err);
						} else {
							// * Valida si no hay registros en el archivo.
							if (!clientesMatrix.length) {
								dbConnection.connectionDB.rollback(() => {
									console.log(
										"No hay registros en el archivo.",
									);
									msgLog.push(
										"No hay registros en el archivo.",
									);
									res.json(msgLog);
								});
							}

							// * Valida si la longitud de la matriz ingresada es mayor a 0.
							if (clientesMatrix.length > 0) {
								const SP_Clientes = "CALL SP_Clientes (?)";
								// clientesMatrix.forEach(
								// 	(clientesArray, index) =>
								// for (let clientesArray in clientesMatrix)
								// for
								clientesMatrix.forEach(
									(clientesArray, index) => {
										let regExp = /[_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;
										// let regExp = /[_DELETE_|_delete_|_DROP_|_drop_|_,_|_%_|_#_|___|_'_|_:_|_;_]+/gimu;

										// TODO: validar la expresión regular
										// if (
										// 	regExp.test(clientesArray[index]) ==
										// 	false
										// ) {
										// 	console.log(
										// 		"Hay registros con caracteres no válidos para el documento.",
										// 	);
										// 	msgLog.push(
										// 		"Hay registros con caracteres no válidos para el documento.",
										// 	);
										// 	counter++;
										// 	if (counter == clientesMatrix.length) {
										// 		console.log(msgLog);
										// 		res.json(msgLog);
										// 		msgLog.length = 0;
										// 	}
										// } else
										if (clientesArray.includes(null)) {
											console.log(
												`Fila ${index + 2
												}: Completar registros vacíos.`,
											);
											msgLog.push(
												`Fila ${index + 2
												}: Completar registros vacíos.`,
											);
											counter++;
											if (
												counter == clientesMatrix.length
											) {
												console.log(msgLog);
												res.json(msgLog);
												msgLog.length = 0;
											}
										} else if (
											!clientesArray.includes(null)
										) {
											dbConnection.connectionDB.query(
												SP_Clientes,
												[clientesArray],
												(error, response) => {
													if (msgLog.length > 0) {
														dbConnection.connectionDB.rollback(
															() => {
																console.log(
																	"ROLLBACK EMPTY FIELDS :>> ",
																);
																console.log(
																	msgLog,
																);
																res.json(
																	msgLog,
																);
																msgLog.length = 0;
															},
														);
													} else {
														if (error) {
															dbConnection.connectionDB.rollback(
																() => {
																	console.log(
																		"QUERY > ROLLBACK ERROR SP_Clientes :>> ",
																		error,
																	);
																	if (
																		error.code ==
																		"ER_DUP_ENTRY"
																	) {
																		console.log(
																			"Base de datos: Registros duplicados.",
																		);
																		res.json(
																			{
																				msg:
																					"Base de datos: Registros duplicados.",
																			},
																		);
																	}
																},
															);
														} else if (response) {
															console.log(
																"QUERY RESPONSE :>> ",
																response,
															);

															dbConnection.connectionDB.commit(
																(err) => {
																	if (err) {
																		dbConnection.connectionDB.rollback(
																			() => {
																				console.log(
																					"COMMIT ERROR ROLLBACK SP_Clientes :>>",
																					err,
																				);
																			},
																		);
																	} else {
																		// console.log(
																		// 	"Archivo cargado / importado correctamente.",
																		// );
																		// msgLog.push(
																		// 	"Archivo cargado / importado correctamente.",
																		// );
																		counter++;
																		if (
																			counter ==
																			clientesMatrix.length
																		) {
																			if (
																				msgLog.length ==
																				0
																			) {
																				msgLog.push(
																					"Archivo cargado / importado correctamente.",
																				);
																			}
																			console.log(
																				msgLog,
																			);
																			res.json(
																				msgLog,
																			);
																			msgLog.length = 0;
																		}
																	}
																},
															);
														}
													}
												},
											);
										}

										// TODO: validar las columnas del arreglo
										// if (clientesArray.length !== 2) {
										// 	console.log(
										// 		"El documento no es válido para 'clientes'.",
										// 	);
										// 	msgLog.push(
										// 		"El documento no es válido para 'clientes'.",
										// 	);
										// 	counter++;
										// 	if (counter == clientesMatrix.length) {
										// 		console.log(msgLog);
										// 		res.json(msgLog);
										// 		msgLog.length = 0;
										// 	}
										// } else {
										// }
									},
								);
							}
						}
					});
				}
			},
		);
	}
};

// #endregion

module.exports.clientesController = clientesController;
