
module.exports  = {
  document : {
    bib       : {extension : 'bib'  , desc : 'BibTeX'                                                        , format : 'BibTeX_Writer'                                },
    doc       : {extension : 'doc'  , desc : 'Microsoft Word 97/2000/XP'                                     , format : 'MS Word 97'                                   },
    doc6      : {extension : 'doc'  , desc : 'Microsoft Word 6.0'                                            , format : 'MS WinWord 6.0'                               },
    doc95     : {extension : 'doc'  , desc : 'Microsoft Word 95'                                             , format : 'MS Word 95'                                   },
    docbook   : {extension : 'xml'  , desc : 'DocBook'                                                       , format : 'DocBook File'                                 },
    docx      : {extension : 'docx' , desc : 'Microsoft Office Open XML'                                     , format : 'Office Open XML Text'                         },
    docx7     : {extension : 'docx' , desc : 'Microsoft Office Open XML'                                     , format : 'MS Word 2007 XML'                             },
    fodt      : {extension : 'fodt' , desc : 'OpenDocument Text (Flat XML)'                                  , format : 'OpenDocument Text Flat XML'                   },
    html      : {extension : 'html' , desc : 'HTML Document (OpenOffice.org Writer)'                         , format : 'HTML (StarWriter)'                            },
    latex     : {extension : 'ltx'  , desc : 'LaTeX 2e'                                                      , format : 'LaTeX_Writer'                                 },
    mediawiki : {extension : 'txt'  , desc : 'MediaWiki'                                                     , format : 'MediaWiki'                                    },
    odt       : {extension : 'odt'  , desc : 'ODF Text Document'                                             , format : 'writer8'                                      },
    ooxml     : {extension : 'xml'  , desc : 'Microsoft Office Open XML'                                     , format : 'MS Word 2003 XML'                             },
    ott       : {extension : 'ott'  , desc : 'Open Document Text'                                            , format : 'writer8_template'                             },
    pdb       : {extension : 'pdb'  , desc : 'AportisDoc (Palm)'                                             , format : 'AportisDoc Palm DB'                           },
    pdf       : {extension : 'pdf'  , desc : 'Portable Document Format'                                      , format : 'writer_pdf_Export'                            },
    psw       : {extension : 'psw'  , desc : 'Pocket Word'                                                   , format : 'PocketWord File'                              },
    rtf       : {extension : 'rtf'  , desc : 'Rich Text Format'                                              , format : 'Rich Text Format'                             },
    sdw       : {extension : 'sdw'  , desc : 'StarWriter 5.0'                                                , format : 'StarWriter 5.0'                               },
    sdw4      : {extension : 'sdw'  , desc : 'StarWriter 4.0'                                                , format : 'StarWriter 4.0'                               },
    sdw3      : {extension : 'sdw'  , desc : 'StarWriter 3.0'                                                , format : 'StarWriter 3.0'                               },
    stw       : {extension : 'stw'  , desc : 'Open Office.org 1.0 Text Document Template'                    , format : 'writer_StarOffice_XML_Writer_Template'        },
    sxw       : {extension : 'sxw'  , desc : 'Open Office.org 1.0 Text Document'                             , format : 'StarOffice XML (Writer)'                      },
    text      : {extension : 'txt'  , desc : 'Text Encoded'                                                  , format : 'Text (encoded)'                               },
    txt       : {extension : 'txt'  , desc : 'Text'                                                          , format : 'Text'                                         },
    uot       : {extension : 'uot'  , desc : 'Unified Office Format text'                                    , format : 'UOF text'                                     },
    vor       : {extension : 'vor'  , desc : 'StarWriter 5.0 Template'                                       , format : 'StarWriter 5.0 Vorlage/Template'              },
    vor4      : {extension : 'vor'  , desc : 'StarWriter 4.0 Template'                                       , format : 'StarWriter 4.0 Vorlage/Template'              },
    vor3      : {extension : 'vor'  , desc : 'StarWriter 3.0 Template'                                       , format : 'StarWriter 3.0 Vorlage/Template'              },
    xhtml     : {extension : 'html' , desc : 'XHTML Document'                                                , format : 'XHTML Writer File'                            }
  },
  web : {
    etext     : {extension : 'txt'  , desc : 'Text Encoded (OpenOffice.org Writer/Web)'                      , format : 'Text (encoded) (StarWriter/Web)'              },
    html10    : {extension : 'html' , desc : 'OpenOffice.org 1.0 HTML Template'                              , format : 'writer_web_StarOffice_XML_Writer_Web_Template'},
    html      : {extension : 'html' , desc : 'HTML Document'                                                 , format : 'HTML'                                         },
    mediawiki : {extension : 'txt'  , desc : 'MediaWiki'                                                     , format : 'MediaWiki_Web'                                },
    pdf       : {extension : 'pdf'  , desc : 'PDF - Portable Document Format'                                , format : 'writer_web_pdf_Export'                        },
    sdw3      : {extension : 'sdw'  , desc : 'StarWriter 3.0 (OpenOffice.org Writer/Web)'                    , format : 'StarWriter 3.0 (StarWriter/Web)'              },
    sdw4      : {extension : 'sdw'  , desc : 'StarWriter 4.0 (OpenOffice.org Writer/Web)'                    , format : 'StarWriter 4.0 (StarWriter/Web)'              },
    sdw       : {extension : 'sdw'  , desc : 'StarWriter 5.0 (OpenOffice.org Writer/Web)'                    , format : 'StarWriter 5.0 (StarWriter/Web)'              },
    txt       : {extension : 'txt'  , desc : 'OpenOffice.org Text (OpenOffice.org Writer/Web)'               , format : 'writerweb8_writer'                            },
    text10    : {extension : 'txt'  , desc : 'OpenOffice.org 1.0 Text Document (OpenOffice.org Writer/Web)'  , format : 'writer_web_StarOffice_XML_Writer'             },
    text      : {extension : 'txt'  , desc : 'Text (OpenOffice.org Writer/Web)'                              , format : 'Text (StarWriter/Web)'                        },
    vor4      : {extension : 'vor'  , desc : 'StarWriter/Web 4.0 Template'                                   , format : 'StarWriter/Web 4.0 Vorlage/Template'          },
    vor       : {extension : 'vor'  , desc : 'StarWriter/Web 5.0 Template'                                   , format : 'StarWriter/Web 5.0 Vorlage/Template'          }
  },
  spreadsheet : {
    dbf   : {extension : 'dbf'  , desc : 'dBASE'                                                         , format : 'dBase'                                        },
    dif   : {extension : 'dif'  , desc : 'Data Interchange Format'                                       , format : 'DIF'                                          },
    fods  : {extension : 'fods' , desc : 'OpenDocument Spreadsheet (Flat XML)'                           , format : 'OpenDocument Spreadsheet Flat XML'            },
    html  : {extension : 'html' , desc : 'HTML Document (OpenOffice.org Calc)'                           , format : 'HTML (StarCalc)'                              },
    ods   : {extension : 'ods'  , desc : 'ODF Spreadsheet'                                               , format : 'calc8'                                        },
    ooxml : {extension : 'xml'  , desc : 'Microsoft Excel 2003 XML'                                      , format : 'MS Excel 2003 XML'                            },
    ots   : {extension : 'ots'  , desc : 'ODF Spreadsheet Template'                                      , format : 'calc8_template'                               },
    pdf   : {extension : 'pdf'  , desc : 'Portable Document Format'                                      , format : 'calc_pdf_Export'                              },
    pxl   : {extension : 'pxl'  , desc : 'Pocket Excel'                                                  , format : 'Pocket Excel'                                 },
    sdc   : {extension : 'sdc'  , desc : 'StarCalc 5.0'                                                  , format : 'StarCalc 5.0'                                 },
    sdc4  : {extension : 'sdc'  , desc : 'StarCalc 4.0'                                                  , format : 'StarCalc 4.0'                                 },
    sdc3  : {extension : 'sdc'  , desc : 'StarCalc 3.0'                                                  , format : 'StarCalc 3.0'                                 },
    slk   : {extension : 'slk'  , desc : 'SYLK'                                                          , format : 'SYLK'                                         },
    stc   : {extension : 'stc'  , desc : 'OpenOffice.org 1.0 Spreadsheet Template'                       , format : 'calc_StarOffice_XML_Calc_Template'            },
    sxc   : {extension : 'sxc'  , desc : 'OpenOffice.org 1.0 Spreadsheet'                                , format : 'StarOffice XML (Calc)'                        },
    uos   : {extension : 'uos'  , desc : 'Unified Office Format spreadsheet'                             , format : 'UOF spreadsheet'                              },
    vor3  : {extension : 'vor'  , desc : 'StarCalc 3.0 Template'                                         , format : 'StarCalc 3.0 Vorlage/Template'                },
    vor4  : {extension : 'vor'  , desc : 'StarCalc 4.0 Template'                                         , format : 'StarCalc 4.0 Vorlage/Template'                },
    vor   : {extension : 'vor'  , desc : 'StarCalc 5.0 Template'                                         , format : 'StarCalc 5.0 Vorlage/Template'                },
    xhtml : {extension : 'xhtml', desc : 'XHTML'                                                         , format : 'XHTML Calc File'                              },
    /* these documents should be in the spreadsheet group but for the moment it is easier to let them here*/
    csv   : {extension : 'csv'  , desc : 'Text CSV'                                                      , format : 'Text - txt - csv (StarCalc)'                  },
    xls   : {extension : 'xls'  , desc : 'Microsoft Excel 97/2000/XP'                                    , format : 'MS Excel 97'                                  },
    xls5  : {extension : 'xls'  , desc : 'Microsoft Excel 5.0'                                           , format : 'MS Excel 5.0/95'                              },
    xls95 : {extension : 'xls'  , desc : 'Microsoft Excel 95'                                            , format : 'MS Excel 95'                                  },
    xlt   : {extension : 'xlt'  , desc : 'Microsoft Excel 97/2000/XP Template'                           , format : 'MS Excel 97 Vorlage/Template'                 },
    xlt5  : {extension : 'xlt'  , desc : 'Microsoft Excel 5.0 Template'                                  , format : 'MS Excel 5.0/95 Vorlage/Template'             },
    xlt95 : {extension : 'xlt'  , desc : 'Microsoft Excel 95 Template'                                   , format : 'MS Excel 95 Vorlage/Template'                 },
    xlsx  : {extension : 'xlsx' , desc : 'Microsoft Excel 2007/2010 XML'                                 , format : 'Calc MS Excel 2007 XML'                       },
  },
  graphics : {
    bmp   : {extension : 'bmp'  , desc : 'Windows Bitmap'                                                , format : 'draw_bmp_Export'                              },
    emf   : {extension : 'emf'  , desc : 'Enhanced Metafile'                                             , format : 'draw_emf_Export'                              },
    eps   : {extension : 'eps'  , desc : 'Encapsulated PostScript'                                       , format : 'draw_eps_Export'                              },
    fodg  : {extension : 'fodg' , desc : 'OpenDocument Drawing (Flat XML)'                               , format : 'OpenDocument Drawing Flat XML'                },
    gif   : {extension : 'gif'  , desc : 'Graphics Interchange Format'                                   , format : 'draw_gif_Export'                              },
    html  : {extension : 'html' , desc : 'HTML Document (OpenOffice.org Draw)'                           , format : 'draw_html_Export'                             },
    jpg   : {extension : 'jpg'  , desc : 'Joint Photographic Experts Group'                              , format : 'draw_jpg_Export'                              },
    met   : {extension : 'met'  , desc : 'OS/2 Metafile'                                                 , format : 'draw_met_Export'                              },
    odd   : {extension : 'odd'  , desc : 'OpenDocument Drawing'                                          , format : 'draw8'                                        },
    otg   : {extension : 'otg'  , desc : 'OpenDocument Drawing Template'                                 , format : 'draw8_template'                               },
    pbm   : {extension : 'pbm'  , desc : 'Portable Bitmap'                                               , format : 'draw_pbm_Export'                              },
    pct   : {extension : 'pct'  , desc : 'Mac Pict'                                                      , format : 'draw_pct_Export'                              },
    pdf   : {extension : 'pdf'  , desc : 'Portable Document Format'                                      , format : 'draw_pdf_Export'                              },
    pgm   : {extension : 'pgm'  , desc : 'Portable Graymap'                                              , format : 'draw_pgm_Export'                              },
    png   : {extension : 'png'  , desc : 'Portable Network Graphic'                                      , format : 'draw_png_Export'                              },
    ppm   : {extension : 'ppm'  , desc : 'Portable Pixelmap'                                             , format : 'draw_ppm_Export'                              },
    ras   : {extension : 'ras'  , desc : 'Sun Raster Image'                                              , format : 'draw_ras_Export'                              },
    std   : {extension : 'std'  , desc : 'OpenOffice.org 1.0 Drawing Template'                           , format : 'draw_StarOffice_XML_Draw_Template'            },
    svg   : {extension : 'svg'  , desc : 'Scalable Vector Graphics'                                      , format : 'draw_svg_Export'                              },
    svm   : {extension : 'svm'  , desc : 'StarView Metafile'                                             , format : 'draw_svm_Export'                              },
    swf   : {extension : 'swf'  , desc : 'Macromedia Flash (SWF)'                                        , format : 'draw_flash_Export'                            },
    sxd   : {extension : 'sxd'  , desc : 'OpenOffice.org 1.0 Drawing'                                    , format : 'StarOffice XML (Draw)'                        },
    sxd3  : {extension : 'sxd'  , desc : 'StarDraw 3.0'                                                  , format : 'StarDraw 3.0'                                 },
    sxd5  : {extension : 'sxd'  , desc : 'StarDraw 5.0'                                                  , format : 'StarDraw 5.0'                                 },
    sxw   : {extension : 'sxw'  , desc : 'StarOffice XML (Draw)'                                         , format : 'StarOffice XML (Draw)'                        },
    tiff  : {extension : 'tiff' , desc : 'Tagged Image File Format'                                      , format : 'draw_tif_Export'                              },
    vor   : {extension : 'vor'  , desc : 'StarDraw 5.0 Template'                                         , format : 'StarDraw 5.0 Vorlage'                         },
    vor3  : {extension : 'vor'  , desc : 'StarDraw 3.0 Template'                                         , format : 'StarDraw 3.0 Vorlage'                         },
    wmf   : {extension : 'wmf'  , desc : 'Windows Metafile'                                              , format : 'draw_wmf_Export'                              },
    xhtml : {extension : 'xhtml', desc : 'XHTML'                                                         , format : 'XHTML Draw File'                              },
    xpm   : {extension : 'xpm'  , desc : 'X PixMap'                                                      , format : 'draw_xpm_Export'                              }
  },
  presentation : {
    bmp   : {extension : 'bmp'  , desc : 'Windows Bitmap'                                                , format : 'impress_bmp_Export'                           },
    emf   : {extension : 'emf'  , desc : 'Enhanced Metafile'                                             , format : 'impress_emf_Export'                           },
    eps   : {extension : 'eps'  , desc : 'Encapsulated PostScript'                                       , format : 'impress_eps_Export'                           },
    fodp  : {extension : 'fodp' , desc : 'OpenDocument Presentation (Flat XML)'                          , format : 'OpenDocument Presentation Flat XML'           },
    gif   : {extension : 'gif'  , desc : 'Graphics Interchange Format'                                   , format : 'impress_gif_Export'                           },
    html  : {extension : 'html' , desc : 'HTML Document (OpenOffice.org Impress)'                        , format : 'impress_html_Export'                          },
    jpg   : {extension : 'jpg'  , desc : 'Joint Photographic Experts Group'                              , format : 'impress_jpg_Export'                           },
    met   : {extension : 'met'  , desc : 'OS/2 Metafile'                                                 , format : 'impress_met_Export'                           },
    odg   : {extension : 'odg'  , desc : 'ODF Drawing (Impress)'                                         , format : 'impress8_draw'                                },
    pbm   : {extension : 'pbm'  , desc : 'Portable Bitmap'                                               , format : 'impress_pbm_Export'                           },
    pct   : {extension : 'pct'  , desc : 'Mac Pict'                                                      , format : 'impress_pct_Export'                           },
    pdf   : {extension : 'pdf'  , desc : 'Portable Document Format'                                      , format : 'impress_pdf_Export'                           },
    pgm   : {extension : 'pgm'  , desc : 'Portable Graymap'                                              , format : 'impress_pgm_Export'                           },
    png   : {extension : 'png'  , desc : 'Portable Network Graphic'                                      , format : 'impress_png_Export'                           },
    ppm   : {extension : 'ppm'  , desc : 'Portable Pixelmap'                                             , format : 'impress_ppm_Export'                           },
    pwp   : {extension : 'pwp'  , desc : 'PlaceWare'                                                     , format : 'placeware_Export'                             },
    ras   : {extension : 'ras'  , desc : 'Sun Raster Image'                                              , format : 'impress_ras_Export'                           },
    sda   : {extension : 'sda'  , desc : 'StarDraw 5.0 (OpenOffice.org Impress)'                         , format : 'StarDraw 5.0 (StarImpress)'                   },
    sdd   : {extension : 'sdd'  , desc : 'StarImpress 5.0'                                               , format : 'StarImpress 5.0'                              },
    sdd3  : {extension : 'sdd'  , desc : 'StarDraw 3.0 (OpenOffice.org Impress)'                         , format : 'StarDraw 3.0 (StarImpress)'                   },
    sdd4  : {extension : 'sdd'  , desc : 'StarImpress 4.0'                                               , format : 'StarImpress 4.0'                              },
    sxd   : {extension : 'sxd'  , desc : 'OpenOffice.org 1.0 Drawing (OpenOffice.org Impress)'           , format : 'impress_StarOffice_XML_Draw'                  },
    sti   : {extension : 'sti'  , desc : 'OpenOffice.org 1.0 Presentation Template'                      , format : 'impress_StarOffice_XML_Impress_Template'      },
    svg   : {extension : 'svg'  , desc : 'Scalable Vector Graphics'                                      , format : 'impress_svg_Export'                           },
    svm   : {extension : 'svm'  , desc : 'StarView Metafile'                                             , format : 'impress_svm_Export'                           },
    swf   : {extension : 'swf'  , desc : 'Macromedia Flash (SWF)'                                        , format : 'impress_flash_Export'                         },
    sxi   : {extension : 'sxi'  , desc : 'OpenOffice.org 1.0 Presentation'                               , format : 'StarOffice XML (Impress)'                     },
    tiff  : {extension : 'tiff' , desc : 'Tagged Image File Format'                                      , format : 'impress_tif_Export'                           },
    uop   : {extension : 'uop'  , desc : 'Unified Office Format presentation'                            , format : 'UOF presentation'                             },
    vor   : {extension : 'vor'  , desc : 'StarImpress 5.0 Template'                                      , format : 'StarImpress 5.0 Vorlage'                      },
    vor3  : {extension : 'vor'  , desc : 'StarDraw 3.0 Template (OpenOffice.org Impress)'                , format : 'StarDraw 3.0 Vorlage (StarImpress)'           },
    vor4  : {extension : 'vor'  , desc : 'StarImpress 4.0 Template'                                      , format : 'StarImpress 4.0 Vorlage'                      },
    vor5  : {extension : 'vor'  , desc : 'StarDraw 5.0 Template (OpenOffice.org Impress)'                , format : 'StarDraw 5.0 Vorlage (StarImpress)'           },
    wmf   : {extension : 'wmf'  , desc : 'Windows Metafile'                                              , format : 'impress_wmf_Export'                           },
    xhtml : {extension : 'xml'  , desc : 'XHTML'                                                         , format : 'XHTML Impress File'                           },
    xpm   : {extension : 'xpm'  , desc : 'X PixMap'                                                      , format : 'impress_xpm_Export'                           },
    // /* these documents should be in presentation */
    odp   : {extension : 'odp'  , desc : 'ODF Presentation'                                              , format : 'impress8'                                     },
    otp   : {extension : 'otp'  , desc : 'ODF Presentation Template'                                     , format : 'impress8_template'                            },
    potm  : {extension : 'potm' , desc : 'Microsoft PowerPoint 2007/2010 XML Template'                   , format : 'Impress MS PowerPoint 2007 XML Template'      },
    pot   : {extension : 'pot'  , desc : 'Microsoft PowerPoint 97/2000/XP Template'                      , format : 'MS PowerPoint 97 Vorlage'                     },
    pptx  : {extension : 'pptx' , desc : 'Microsoft PowerPoint 2007/2010 XML'                            , format : 'Impress MS PowerPoint 2007 XML'               },
    pps   : {extension : 'pps'  , desc : 'Microsoft PowerPoint 97/2000/XP (Autoplay)'                    , format : 'MS PowerPoint 97 Autoplay'                    },
    ppt   : {extension : 'ppt'  , desc : 'Microsoft PowerPoint 97/2000/XP'                               , format : 'MS PowerPoint 97'                             }
  }
};

